Package org.apache.sling.servlets.post

# Schnittstelle JakartaPostResponse

Alle bekannten Implementierungsklassen:
  `AbstractJakartaPostResponse`, `AbstractJakartaPostResponseWrapper`, `JakartaHtmlResponse`, `JakartaJSONResponse`, `JavaxToJakartaPostResponse`

public interface JakartaPostResponse
The `PostResponse` interface defines the API of a response container which can (and should) be used by `JakartaPostOperation` services to prepare responses to be sent back to the client.

This bundle provides a preconfigured `JakartaHtmlResponse` and a `JakartaJSONResponse` implementation of this interface. Clients may extend the `AbstractJakartaPostResponse` class to provide their own response implementations.

Seit:
  2.5.0

## Methodenübersicht

Modifizierer und Typ
Methode
Beschreibung
`Throwable`
`getError()`
Returns any recorded error or `null`
`String`
`getLocation()`
Returns the location of the modification.
`String`
`getParentLocation()`
Returns the parent location of the modification.
`String`
`getPath()`
Returns the absolute path of the item upon which the request operated.
`String`
`getReferer()`
Returns the referer previously set by `setReferer(String)`
`int`
`getStatusCode()`
Returns the status code of this instance.
`String`
`getStatusMessage()`
Returns the status message or `null` if no has been set with the `setStatus(int, String)` method.
`boolean`
`isCreateRequest()`
Returns `true` if this was a create request.
`boolean`
`isSuccessful()`
Returns `true` if no `error` is set and if the `status code` is one of the 2xx codes.
`void`
`onChange(String type, String... arguments)`
Records a generic change of the given `type` with arguments.
`void`
`onCopied(String srcPath, String dstPath)`
Records a 'copied' change.
`void`
`onCreated(String path)`
Records a 'created' change
`void`
`onDeleted(String path)`
Records a 'deleted' change
`void`
`onModified(String path)`
Records a 'modified' change
`void`
`onMoved(String srcPath, String dstPath)`
Records a 'moved' change.
`void`
`send(jakarta.servlet.http.HttpServletResponse response, boolean setStatus)`
Writes the response back over the provided HTTP channel.
`void`
`setCreateRequest(boolean isCreateRequest)`
Sets whether the request was a create request or not.
`void`
`setError(Throwable error)`
Sets the recorded error causing the operation to fail.
`void`
`setLocation(String location)`
Sets the location of this modification.
`void`
`setParentLocation(String parentLocation)`
Sets the parent location of the modification.
`void`
`setPath(String path)`
Sets the absolute path of the item upon which the request operated.
`void`
`setReferer(String referer)`
Sets the referer property
`void`
`setStatus(int code, String message)`
Sets the response status code properties
`void`
`setTitle(String title)`
Sets the title of the response message

## Methodendetails

### setReferer

void setReferer(String referer)
Sets the referer property

Parameter:
  `referer` - the referer

### getReferer

String getReferer()
Returns the referer previously set by `setReferer(String)`

Gibt zurück:
  the referer

### setPath

void setPath(String path)
Sets the absolute path of the item upon which the request operated.

Parameter:
  `path` - the path

### getPath

String getPath()
Returns the absolute path of the item upon which the request operated.

If the `setPath(String)` method has not been called yet, this method returns `null`.

Gibt zurück:
  the path (might be null)

### setCreateRequest

void setCreateRequest(boolean isCreateRequest)
Sets whether the request was a create request or not.

Parameter:
  `isCreateRequest` - true if the request was a create request

### isCreateRequest

boolean isCreateRequest()
Returns `true` if this was a create request.

Before calling the `setCreateRequest(boolean)` method, this method always returns `false`.

Gibt zurück:
  if this was a create request

### setLocation

void setLocation(String location)
Sets the location of this modification. This is the externalized form of the `current path`.

Parameter:
  `location` - the location

### getLocation

String getLocation()
Returns the location of the modification.

If the `setLocation(String)` method has not been called yet, this method returns `null`.

Gibt zurück:
  the location

### setParentLocation

void setParentLocation(String parentLocation)
Sets the parent location of the modification. This is the externalized form of the parent node of the `current path`.

Parameter:
  `parentLocation` - the parent location of the modification

### getParentLocation

String getParentLocation()
Returns the parent location of the modification.

If the `setParentLocation(String)` method has not been called yet, this method returns `null`.

Gibt zurück:
  the parent location

### setTitle

void setTitle(String title)
Sets the title of the response message

Parameter:
  `title` - the title

### setStatus

void setStatus(int code, String message)
Sets the response status code properties

Parameter:
  `code` - the code
  `message` - the message

### getStatusCode

int getStatusCode()
Returns the status code of this instance. If the status code has never been set by calling the `setStatus(int, String)` method, the status code is determined by checking if there was an error. If there was an error, the response is assumed to be unsuccessful and 500 is returned. If there is no error, the response is assumed to be successful and 200 is returned.

Gibt zurück:
  the status code

### getStatusMessage

String getStatusMessage()
Returns the status message or `null` if no has been set with the `setStatus(int, String)` method.

Gibt zurück:
  the status message (might be null)

### setError

void setError(Throwable error)
Sets the recorded error causing the operation to fail.

Parameter:
  `error` - the throwable

### getError

Throwable getError()
Returns any recorded error or `null`

Gibt zurück:
  an error or `null`

### isSuccessful

boolean isSuccessful()
Returns `true` if no `error` is set and if the `status code` is one of the 2xx codes.

Gibt zurück:
  true if the status code is 2xx

### onCreated

void onCreated(String path)
Records a 'created' change

Parameter:
  `path` - path of the item that was created

### onModified

void onModified(String path)
Records a 'modified' change

Parameter:
  `path` - path of the item that was modified

### onDeleted

void onDeleted(String path)
Records a 'deleted' change

Parameter:
  `path` - path of the item that was deleted

### onMoved

void onMoved(String srcPath, String dstPath)
Records a 'moved' change.

Note: the moved change only records the basic move command. the implied changes on the moved properties and sub nodes are not recorded.

Parameter:
  `srcPath` - source path of the node that was moved
  `dstPath` - destination path of the node that was moved.

### onCopied

void onCopied(String srcPath, String dstPath)
Records a 'copied' change.

Note: the copy change only records the basic copy command. the implied changes on the copied properties and sub nodes are not recorded.

Parameter:
  `srcPath` - source path of the node that was copied
  `dstPath` - destination path of the node that was copied.

### onChange

void onChange(String type, String... arguments)
Records a generic change of the given `type` with arguments.

Parameter:
  `type` - The type of the modification
  `arguments` - The arguments to the modifications

### send

void send(jakarta.servlet.http.HttpServletResponse response, boolean setStatus) throws IOException
Writes the response back over the provided HTTP channel. The actual format of the response is implementation dependent.

Parameter:
  `response` - to send to
  `setStatus` - whether to set the status code on the response
Löst aus:
  `IOException` - if an i/o exception occurs